package ucot;

import java.util.MissingResourceException;
import java.util.ResourceBundle;
/**
 * This class contains interface to the localised message strings.
 * 
 * Strings are readed using ResourceBundle that uses ucot/message.properties file
 * (or its localized version).
 *
 */
public class Messages {
	private static final String BUNDLE_NAME = "ucot.messages"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	private Messages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
