package ucot.heuristic;
import java.util.Properties;

import ucot.model.AnalyzeModel;
import ucot.parser.ParsedData;

/**
 * Interface for all heuristics used by UCOT.
 * Takes ParsedData and stores analyzemodel to given model. Appends if possible.
 * @author vevijopi
 *
 */
public interface HeuristicInterface {	
	/**
	 * Performs heuristic on given ParsedData object returns 
	 * @param data Parsed usecase for the heuristic
	 * @param model analyze model where parseddata is added to
	 */
	public void doHeuristic(ParsedData data, AnalyzeModel model) throws Exception;
	
	/**
	 * Returns adapter's name
	 * @return
	 */
	public String getName();
	
	/**
	 * Sets options for the adapter
	 * @param options options for the adapter
	 */
	public void setOptions(Properties options);
	
	/**
	 * Returns adapter's options
	 * @return adapter's options
	 */
	public Properties getOptions();
}
