package ucot.model;

import java.util.Observer;

/**
 * Interface for analyze models
 * @author pajumasu
 *
 */
public interface AnalyzeModel {

	/**
	 * return editor for this analyze model
	 * @return ModelEditor
	 */
	public ModelEditor getEditor();
	
	/**
	 * Adds observer for this analyzemodel
	 * @param observer
	 */
	public void addObserver(Observer observer);
	/**
	 * Signals all observers that this model 
	 * is ready.
	 */
	
	public void readySignal();
	/**
	 * Signals all observers that this model 
	 * is beign modified.
	 */
	public void updationStartedSignal();
	
	/**
	 * Clears this analyze model
	 *
	 */
	public void clear();
}