package ucot.model;

import ucot.model.relation.Thing;
/**
 * Class contains updation information about the model.
 * This message caries information to the observers so they 
 * can act accordingly.
 * 
 * XXX: Pit muokata pois tuo thing tst rakenteesta ja vlitt tieto muutoksen kohteesta muuten.
 *  
 * @author pajumasu
 */
public class Updation {
	public enum UpdationType{
		/**
		 * Modification occurred.
		 */
		MODIFY,
		/**
		 * Cration ocurred.
		 */
		NEW,
		/**
		 * Deletion ocurred.
		 * The Thing contains the deleted thing. 
		 */
		DELETION,
		
		/**
		 * Model has just been complety wiped out.
		 */
		CLEAR,
		
		/**
		 * Big chunk of modification is done.
		 */
		READY,
		/**
		 * Big chunk of modification started. Time intensive
		 * updations should be cased and wait for ready signal.
		 */
		MODIFICATION_STARTED};
		
		
	UpdationType type;
	
	
	Thing thing;
	
	public Updation(UpdationType type, Thing thing){
		this.type = type;
		this.thing = thing; 
	}
	
	public Thing getThing(){
		return thing;
	}
	public UpdationType getType(){
		return type;
	}
}
