package ucot.model.relation;

/**
 * Relation connects Thing in the model to other things.
 * Relation is directed link between Things that has
 * name and type. 
 * @author panu
 *
 */
public class Relation extends Thing{
    Thing from;
    String fromCardinal = "";
    String toCardinal = "";
    Thing to;
    RelationType type;
    
    public Relation(Thing from, String methodName, Thing to) {
        super(methodName.toLowerCase(),"relation");
        type = RelationType.INFLUENCE_BY_METHOD;
        this.from = from;
        this.to = to;
    }
    
    public Relation(Thing from, RelationType type, Thing to) {
        super(type.toString().toLowerCase(),"relation");
        this.type = type;
        this.from = from;
        this.to = to;
    }
    
    public Thing getFrom() {
        return from;
    }
    public void setFrom(Item from) {
        this.from = from;
    }
   
    public Thing getTo() {
        return to;
    }
    public void setTo(Item to) {
        this.to = to;
    }
    public RelationType getType() {
        return type;
    }
    public void setType(RelationType type) {
        this.type = type;
    }
    
 

	public String getFromCardinal() {
		return fromCardinal;
	}

	public void setFromCardinal(String fromCardinal) {
		this.fromCardinal = fromCardinal;
	}

	public String getToCardinal() {
		return toCardinal;
	}

	public void setToCardinal(String toCardinal) {
		this.toCardinal = toCardinal;
	}

	public boolean equals(Object o){
        if (o instanceof Relation){
            Relation r = (Relation) o;
            return 
            r.getType().equals(getType()) 
            && r.getName().equals(getName()) 
            && r.getTo().equals(getTo()) 
            && r.getFrom().equals(getFrom());
        }
        return false;
    }
    
   
    public int hashCode() {
        String tmp = getFrom()+getName()+getTo()+getType().toString();
        return tmp.hashCode();
    }
    public String toString(){
        return from.toString() +" - " + getName() + " -> " + getTo();
    }
}
