package ucot.output;
import java.net.URL;
import java.util.Properties;

import ucot.model.AnalyzeModel;

/**
 * Interface for outputs used by UCOT.
 * Outputs store analyzemodel to a given url. Each Output component stores
 * analyze model in a different way/format.
 * @author vevijopi
 *
 */
public interface OutputInterface {
	/**
	 * Outputs analyze model.
	 * @param model Analyze model to output
	 */
	public void output(AnalyzeModel model, URL url) throws Exception;
	
	/**
	 * Returns adapter's name
	 * @return
	 */
	public String getName();
	
	/**
	 * Sets options for the adapter
	 * @param options options for the adapter
	 */
	public void setOptions(Properties options);
	
	/**
	 * Returns adapter's options
	 * @return adapter's options
	 */
	public Properties getOptions();
}
