package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

public class AttributesTreeItem extends TreeItem {

    private String object;
    
    public AttributesTreeItem(AnalyzeTreeModel model, TreeItem parent, String object) {
        super(model, parent);
        this.object = object;
    }

    @Override
    public String getName() {
        return "attributes";
    }
    
    public Object getData() {
        return this.getName();
    }
    
    public List getChildren() {
        List children = new Vector<TreeItem>();
        Set<String> attributes = getAnalyzeModel().getEditor().getAttributeNames(object);
        for (String attribute : attributes) {
            children.add( new AttributeTreeItem(getTreeModel(), this, this.object, attribute) );
        }
        return children;
    }

}
