package ucot.ui.gui.tree;

import java.util.List;
import java.util.Vector;

import ucot.model.relation.Entity;
import ucot.model.relation.Thing;

public class EntityTreeItem extends TreeItem {
	String object;
	boolean expand;
	public EntityTreeItem(AnalyzeTreeModel model,TreeItem parent, String object) {
		this (model, parent,object, true);
	}
	public EntityTreeItem(AnalyzeTreeModel model, TreeItem parent, String object, boolean expand) {
		super(model,parent);
		this.object = object;
		this.expand = expand;	
	}
	
	public String getName() {
		return object;
	}
	
	public Object getData() {
		return object;
	}
	
	public List getChildren() {
		if (expand){
			List<TreeItem> items = new Vector<TreeItem>();
			TreeItem methods = new MethodsTreeItem(getTreeModel(),this, object);
            TreeItem attributes = new AttributesTreeItem(getTreeModel(), this, this.object);
            TreeItem inheritsFrom = new InheritancesTreeItem(getTreeModel(), this, this.object);
            
            if (methods.getChildren().size() > 0) {
				items.add(methods);
            }
            if (attributes.getChildren().size() > 0) {
                items.add(attributes);
            }
            if (inheritsFrom.getChildren().size() > 0) {
                items.add(inheritsFrom);
            }
                
			return items;
		}
		else return new Vector();
	}
	
	public List<TreeItem> getRelevants(Thing thing){		 
		List<TreeItem> ret = new Vector<TreeItem>();
		if (thing.equals(getData())){
			ret.add(this); 
		} else {
			ret.addAll(super.getRelevants(thing));
		}
		return ret;
	}
	
}
