package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

public class InheritancesTreeItem extends TreeItem {

    private String object;
    
    public InheritancesTreeItem(AnalyzeTreeModel model, TreeItem parent, String object) {
        super(model, parent);
        this.object = object;
    }

    @Override
    public String getName() {
        return "inherits from";
    }
    
    public Object getData() {
        return this.getName();
    }

    
    public List getChildren() {
        List children = new Vector<TreeItem>();
        Set<String> inheritsFrom = getAnalyzeModel().getEditor().getParents(object);
        for (String parent : inheritsFrom) {
            children.add( new InheritanceTreeItem(this.getTreeModel(), this, parent) );
        }
        return children;
    }
}
