package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

import ucot.model.relation.Entity;
import ucot.model.relation.Method;
import ucot.model.relation.Relation;
import ucot.model.relation.Thing;

public class MethodTreeItem extends TreeItem {
	String method;
	String object;
	public MethodTreeItem(AnalyzeTreeModel model, TreeItem parent, String object, String method) {
		super(model,parent);
		this.method = method;
		this.object = object;
	}
	
	public String getName() {
		return method;
	}
	
	
	public Object getData() {
		return method;
	}
	public List getChildren() {
		List<TreeItem> items = new Vector<TreeItem>();
		Set<String> relatedEntities = getAnalyzeModel().getEditor().getEntitiesInfluencedByMethod(object,method);
		for(String  entity: relatedEntities){
			TreeItem item = new EntityTreeItem(getTreeModel(), this,entity, false);
			items.add(item);
		}
		return items;
	}
	
	public List<TreeItem> getRelevants(Thing thing){
		List<TreeItem> ret = new Vector<TreeItem>();
		/*if (thing instanceof Relation){
			Relation relation = ((Relation) thing);
			if (relation.getName().equals(method.getName()))	
				ret.add(this);
			
			
		}*/
		return ret;
	}
}
