package ucot.ui.gui.tree;

import java.util.List;
import java.util.Set;
import java.util.Vector;

import ucot.model.relation.Entity;
import ucot.model.relation.Method;
import ucot.model.relation.Relation;

public class MethodsTreeItem extends TreeItem {
	String object;
	
	public MethodsTreeItem(AnalyzeTreeModel model, TreeItem parent,String object) {
		super(model,parent);
		this.object = object;
	}
	
	public String getName() {
		return "methods";
	}
	
	public Object getData() {
		return getName();
	}
	
	public List getChildren() {
		List<TreeItem> items = new Vector<TreeItem>();
		Set<String> methods = getAnalyzeModel().getEditor().getMethodNames(object);
		for (String  method: methods) {
			TreeItem methodItem = new MethodTreeItem(getTreeModel(),this,object, method);
			items.add(methodItem);
		}
		return items;
	}
}
