package ucot.ui.gui.tree.usecasetree;

import java.net.URL;
import java.util.List;
import java.util.Vector;

import ucot.input.UseCase;

public class FileTreeItem extends TreeItem {

    private URL url;
    
    public FileTreeItem(UseCaseTreeModel treemodel, TreeItem parent, URL url) {
        super(treemodel, parent);
        this.url = url;
    }

    @Override
    public String getName() {
        
        // return the filename from url (or the last path component)
        int i = url.getFile().lastIndexOf("/");
        return url.getFile().substring(i + 1);
    }
    
    public Object getData() {
        return url;
    }
    
    public List getChildren() {
        List<UseCaseTreeItem> list = new Vector<UseCaseTreeItem>();
        List<UseCase> cases = this.treemodel.getUseCaseCollection().getUseCasesFromURL(this.url);
        for (UseCase u : cases) {
            list.add(new UseCaseTreeItem(this.treemodel, this, u));
        }
        
        return list;
    }

}
