package ucot.ui.gui.tree.usecasetree;

import java.util.List;
import java.util.Vector;

import ucot.input.UseCase;
import ucot.input.UseCaseStep;

public class UseCaseTreeItem extends TreeItem {

    private UseCase usecase;
    private boolean inAnalyzeModel; 
    
    public UseCaseTreeItem(UseCaseTreeModel treemodel, TreeItem parent, UseCase u) {
        super(treemodel, parent);
        this.usecase = u;
    }

    @Override
    public String getName() {
        return this.usecase.getName();
    }
    
    public Object getData() {
        return this.getName();
    }
    
    public boolean isUsecaseInAnalyzemodel() {
        return this.usecase.isUseCaseAnalyzed();
    }
    
    public UseCase getUseCase() {
        return this.usecase;
    }
        
    public List getChildren() {
        List<UseCaseTreeItem> list = new Vector<UseCaseTreeItem>();
        for (int i = 0; i < this.usecase.getStepCount(); i++) {
            UseCaseStep step = this.usecase.getStep(i); 
            
            if (step.getSubUseCase() != null) {
                list.add(new UseCaseTreeItem(this.treemodel, this, step.getSubUseCase()));
            }
        }
        return list;
    }

}
